<template>
  <div class="ob-form-controls-container">
    <template v-if="isOnlySubmit">
      <ObButton
        data-attr-el="ob-form-controls-container"
        class="w100"
        :label="okText"
        :disabled="isSubmitDisabled"
        :danger="isError"
        :data-qa="dataQa + '_btnOk'"
        @click="submit"
      />
    </template>
    <template v-else>
      <div class="form-controls__left">
        <template v-if="isReadOnly && !isOnlySubmit">
          <ObButton
            data-attr-el="ob-form-controls-container"
            :label="closeText"
            :danger="isError"
            :data-qa="dataQa + '_btnClose'"
            @click="cancel"
          />
        </template>
        <template v-else>
          <ObButton
            data-attr-el="ob-form-controls-container"
            :label="okText"
            :disabled="isSubmitDisabled"
            :danger="isError"
            :data-qa="dataQa + '_btnOk'"
            @click="submit"
          />
          <ObButton
            v-show="!isOnlySubmit"
            data-attr-el="ob-form-controls-container"
            :disabled="isCancelDisabled && !isFormChanged"
            :label="cancelText"
            type="flat"
            :data-qa="dataQa + '_btnCancel'"
            @click="cancel"
          />
        </template>
      </div>
      <div class="form-controls__right">
        <template v-if="isExistActiveElement">
          <ObSwitcher
            class="form-controls__is-active"
            :label-right="isActiveElementLabel"
            :value="isActiveElement"
            :data-qa="dataQa"
            @input="onChangeActiveHandler"
          />
        </template>
        <template v-if="btnModal">
          <ObButton
            class="form-controls__btn-modal"
            :label="btnModal + '...'"
            type="flat"
            :data-qa="dataQa + '_btnModal'"
            @click="$emit('on-btn-modal')"
          />
        </template>
        <ObMenuDropdown
          v-if="dropdownMenu.length"
          :data-qa="dataQa"
          :items="dropdownMenu"
        />
      </div>
    </template>
  </div>
</template>

<script>
import ObMenuDropdown from '../obMenuDropdown/index'
import ObButton from '../obButton/index'
import ObSwitcher from '../obSwitcher'

export default {
  name: 'ObFormControls',
  components: {
    ObMenuDropdown,
    ObButton,
    ObSwitcher
  },
  props: {
    isReadOnly: {
      type: Boolean,
      default: false
    },
    isOnlySubmit: {
      type: Boolean,
      default: false
    },
    okText: {
      type: String,
      default: 'Сохранить'
    },
    cancelText: {
      type: String,
      default: 'Отмена'
    },
    closeText: {
      type: String,
      default: 'Закрыть'
    },
    isSubmitDisabled: {
      type: Boolean,
      default: false
    },
    isCancelDisabled: {
      type: Boolean,
      default: false
    },
    dropdownMenu: {
      type: Array,
      default: () => []
    },
    isWatchForm: {
      type: Boolean,
      default: true
    },
    isError: {
      type: Boolean,
      default: false
    },
    isActiveElement: {
      type: Boolean,
      default: null
    },
    btnModal: {
      type: String,
      default: null
    },
    dataQa: {
      type: String
    }
  },
  data () {
    return {
      customMenuVisibleStatus: false
    }
  },
  computed: {
    parentModal () {
      const getParent = (component) => {
        if (component.$options && component.$options.name && component.$options.name === 'ObModal') {
          return component
        }

        if (!component || !component.$parent) {
          return null
        } else {
          return getParent(component.$parent)
        }
      }

      return getParent(this.$parent)
    },
    parentForm () {
      const getParent = (component) => {
        if (component.$options && component.$options.name && component.$options.name === 'ObForm') {
          return component
        }

        if (!component || !component.$parent) {
          return null
        } else {
          return getParent(component.$parent)
        }
      }

      return getParent(this.$parent)
    },
    isFormChanged () {
      return this.parentForm.formIsChanged
    },
    submitBtnDisabled () {
      return this.isWatchForm && this.parentForm && this.parentForm.formModel ? !this.parentForm.isValid || !this.parentForm.formIsChanged : this.submitDisabled
    },
    isExistActiveElement () {
      return this.isActiveElement !== null
    },
    isActiveElementLabel () {
      return this.isActiveElement ? 'Активно' : 'Неактивно'
    }
  },
  methods: {
    submit () {
      this.$emit('submit')
      if (this.parentModal && this.parentModal.loading) {
        this.parentModal.loading(true)
      }
    },
    cancel () {
      this.$emit('cancel')
      this.close()
    },
    close () {
      if (this.parentModal && this.parentModal.cancel && this.parentForm) {
        this.parentModal.cancel()
      }
    },
    onChangeActiveHandler (val) {
      this.$emit('on-change-active', val)
    }
  }
}
</script>

<style lang="scss">
  .ob-form-controls-container {
    width: 100%;
    display: flex;
    justify-content: space-between;
    align-items: center;
    height: 40px;
    .form-controls {
      &__left {
        display: flex;
        justify-content: space-between;
        align-items: center;
        flex-wrap: nowrap;
        min-width: 0;
        button {
          white-space: nowrap;
          width: auto;
          min-width: 100px;
          padding: 0 20px;
          margin-right: 10px;
          span {
            display: block;
            max-width: 100%;
            overflow: hidden;
            text-overflow: ellipsis;
          }
        }
      }
      &__right {
        display: flex;
        justify-content: space-between;
        align-items: center;
        margin-left: 5px;
        button {
          width: auto;
          padding: 0 20px;
        }
      }
      &__is-active:not(:last-child) {
        // .ob-menu-dropdown-container has 'translateX(10px)', so 30px offset is equal to 40px
        margin-right: 30px;
      }
      &__btn-modal {
        margin-right: 10px;
      }
    }
  }
</style>

<style scoped>
  .w100 { width: 100%!important; }
</style>
